//---------------------------------------------------------------------------

#include <iostream>
#include <fstream>

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <math.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MemoEx"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
/*
  Fill styles with default attributes.
*/
void __fastcall TForm1::SetDefaultTextStyle(int ATextStyle, TColor FC, TColor BC, TFontStyles Style, int ExStyle)
{
  Styles[ATextStyle].FC = FC;
  Styles[ATextStyle].BC = BC;
  Styles[ATextStyle].Style = Style;
  Styles[ATextStyle].ex_style = ExStyle;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetDefaultTextStyles()
{
  SetDefaultTextStyle(_STYLE_NORMAL, clWindowText, clWindow, TFontStyles(), 0);
  SetDefaultTextStyle(_STYLE_INVISIBLE, clWindow, clWindow, TFontStyles(), 0);
  SetDefaultTextStyle(_STYLE_BOLD, clWindowText, clWindow, TFontStyles() << fsBold, 0);
  SetDefaultTextStyle(_STYLE_ITALIC, clWindowText, clWindow, TFontStyles() << fsItalic, 0);
  SetDefaultTextStyle(_STYLE_UNDERLINE, clWindowText, clWindow, TFontStyles() << fsUnderline, 0);
  SetDefaultTextStyle(_STYLE_SPECIAL, clMaroon, clWindow, TFontStyles() << fsBold, 0);
  SetDefaultTextStyle(_STYLE_HOTSPOT, clBlue, clWindow, TFontStyles() << fsUnderline, _STYLE_HOTSPOT);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
  cblSettings->Checked[0] = true;       //  word wrap
  cblSettings->Checked[1] = true;       //  read-only
  cblSettings->Checked[2] = true;       //  highlight
  cblSettings->Checked[3] = true;       //  strip invisible
  cblSettings->Checked[4] = true;       //  cursor beyond end of line
  cblSettings->Checked[5] = false;      //  cursor beyond end of file
  cblSettings->Checked[6] = true;       //  auto indent
  cblSettings->Checked[7] = true;       //  smart auto indent
  cblSettings->Checked[8] = false;      //  smart tab
  cblSettings->Checked[9] = true;       //  simple begin line
  cblSettings->Checked[10] = true;      //  right margin visible
  cblSettings->Checked[11] = true;      //  enabled
  cblSettings->Checked[12] = true;      //  completion enabled
  cblSettings->Checked[13] = false;     //  unicode output
  cblSettings->Checked[14] = false;     //  auto word wrap
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  //  enable syntax highlighting by default
  SyntaxHighlight = true;
  SetDefaultTextStyles();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnApplySettingsClick(TObject *Sender)
{
  //  apply all selected settings to control
  bool NeedRedraw = (MemoEx1->ReadOnly != cblSettings->Checked[1]) ||
                      (SyntaxHighlight != cblSettings->Checked[2]) ||
                      (MemoEx1->StripInvisible != cblSettings->Checked[3]);
  MemoEx1->WordWrap = cblSettings->Checked[0];
  MemoEx1->ReadOnly = cblSettings->Checked[1];
  SyntaxHighlight = cblSettings->Checked[2];
  MemoEx1->StripInvisible = cblSettings->Checked[3];
  MemoEx1->CursorBeyondEOL = cblSettings->Checked[4];
  MemoEx1->CursorBeyondEOF = cblSettings->Checked[5];
  MemoEx1->AutoIndent = cblSettings->Checked[6];
  MemoEx1->SmartAutoIndent = cblSettings->Checked[7];
  MemoEx1->SmartTab = cblSettings->Checked[8];
  MemoEx1->SimpleBeginLine = cblSettings->Checked[9];
  MemoEx1->RightMarginVisible = cblSettings->Checked[10];
  MemoEx1->Enabled = cblSettings->Checked[11];
  MemoEx1->Completion->Enabled = cblSettings->Checked[12];
  MemoEx1->RightMargin = StrToIntDef(edRightMargin->Text, 80);
  MemoEx1->AutoIndentSize = StrToIntDef(edAutoIndentSize->Text, 0);
  MemoEx1->IndentSize = StrToIntDef(edIndentSize->Text, 4);
  MemoEx1->TabSize = StrToIntDef(edTabSize->Text, 4);
  MemoEx1->GutterWidth = StrToIntDef(edGutterWidth->Text, 30);
  if (NeedRedraw) MemoEx1->Invalidate2();
  MemoEx1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1SelectionChange(TObject *Sender)
{
  //  perform interface updates depending on text selection changes
  AnsiString s;
  if (MemoEx1->SelectedText) s = "selection present";
  else s = "selection is not present";
  MemoExStatus->Panels->Items[3]->Text = s;
  Copy1->Enabled = MemoEx1->SelectedText;
  Cut1->Enabled = MemoEx1->SelectedText;
  Delete1->Enabled = MemoEx1->SelectedText;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1ChangeClipboardState(TObject *Sender,
      const bool CanPaste)
{
  //  perform interface updates depending on clipboard contents
  AnsiString s;
  if (CanPaste) s = "can paste text";
  else s = "no text to paste";
  MemoExStatus->Panels->Items[4]->Text = s;
  Paste1->Enabled = CanPaste;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1ChangeStatus(TObject *Sender)
{
  //  perform interface updates depending on status changes
  AnsiString s;
  MemoExStatus->Panels->Items[0]->Text = Format("%d: %d", ARRAYOFCONST(((int) (MemoEx1->CaretX + 1), (int) (MemoEx1->CaretY + 1))));
  if (MemoEx1->Recording) s = "macro recording";
  else
    if (MemoEx1->InsertMode) s = "insert";
    else s = "overwrite";
  MemoExStatus->Panels->Items[1]->Text = s;
  if (MemoEx1->CanUndo) s = "can undo";
  else s = "no operations to undo";
  MemoExStatus->Panels->Items[2]->Text = s;
  Undo1->Enabled = MemoEx1->SelectedText;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cblSettingsEnter(TObject *Sender)
{
  btnApplySettings->Default = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cblSettingsExit(TObject *Sender)
{
  btnApplySettings->Default = false;
}
//---------------------------------------------------------------------------

//  Not changed Attr[AIndex].BC always defaults to MemoEx.Color property.
#define SetTextStyle(AIndex, AStyle) \
{\
  Attrs[AIndex] = Styles[AStyle];\
}

void __fastcall TForm1::MemoEx1GetLineAttr(TObject *Sender,
      const AnsiString Line, int Index, const TSelAttrs SelAttrs,
      TLineAttrs &Attrs)
{
  int i, j, k, x1, x2;
  //  If we do not need to highlight the text, we leave.
  if (!SyntaxHighlight) return;

  /*
    Search for lines which starts with '>' -- special lines.
  */
  bool b = false;
  for (i = 1; i < Line.Length(); i++)
    if (i < 10)
    {
      if (Line[i] == 62)
      {
        //  The line starts with '>' is what we need.
        b = true;
        break;
      }
    }
    else break;
  if (b) {
    for (i = 1; i <= Line.Length(); i++) SetTextStyle(i - 1, _STYLE_SPECIAL);
    return;
  }

  j = _STYLE_NORMAL;                     //  normal style
  x1 = 0;
  x2 = 0;
  for (i = 1; i <= Line.Length(); i++)
  {
    switch (Line[i]) {
      case 32:                                 //  space resets any style to normal
        k = _STYLE_NORMAL;
        j = _STYLE_NORMAL;
        x1 = 0;
        x2 = 0;
        break;
      case 42:                                 //  bold (*text*)
        k = _STYLE_BOLD;
        break;
      case 47:                                 //  italic (/text/)
        k = _STYLE_ITALIC;
        break;
      case 95:                                 //  underline (_text_)
        k = _STYLE_UNDERLINE;
        break;
      case 126:                                //  hotspot (~text~)
        k = _STYLE_HOTSPOT;
        break;
      default:                                 //  normal
        k = _STYLE_NORMAL;
        break;
    }
    if (k > _STYLE_NORMAL)
    {
      if ((j == _STYLE_NORMAL) || (j != k))
      {
        x1 = i;
        j = k;
        x2 = 0;
      }
      else
        if (j == k) x2 = i;
      if ((x1 > 0) && (x2 - 1 >= x1 + 1))
      {
        //  Highlight the text.
        for (k = x1 + 1; k < x2; k++) SetTextStyle(k - 1, j);
        if (MemoEx1->ReadOnly)
        {
          SetTextStyle(x1 - 1, _STYLE_INVISIBLE);
          SetTextStyle(x2 - 1, _STYLE_INVISIBLE);
        }
        j = _STYLE_NORMAL;
        x1 = 0;
        x2 = 0;
      }
      else
        if ((x1 > 0) && (x2 > 0))
        {
          //  Oops. We shouldn't reach this place.
          x1 = 0;
          x2 = 0;
        }
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1MouseOver(TObject *Sender, WORD WordStyle,
      TCursor &_Cursor)
{
  //  mouse was moved over word, let's check the word style and update a cursor
  if (WordStyle == _STYLE_HOTSPOT) _Cursor = crHandPoint;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1WordClick(TObject *Sender,
      const AnsiString WordText, WORD WordStyle)
{
  //  user has clicked a left mouse button, let's check the word style
  if (WordStyle == _STYLE_HOTSPOT)
    MessageDlg(Format("\"%s\" clicked!", ARRAYOFCONST(((AnsiString) WordText))), mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Undo1Click(TObject *Sender)
{
  //  undo, from pop-up menu
  MemoEx1->Undo();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Cut1Click(TObject *Sender)
{
  //  cut to clipboard, from pop-up menu
  MemoEx1->CutToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Copy1Click(TObject *Sender)
{
  //  copy to clipboard, from pop-up menu
  MemoEx1->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Paste1Click(TObject *Sender)
{
  //  paste from clipboard, from pop-up menu
  MemoEx1->PasteFromClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Delete1Click(TObject *Sender)
{
  //  delete a selected text, from pop-up menu
  MemoEx1->ClearSelection();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SelectAll1Click(TObject *Sender)
{
  //  select all text from pop-up menu
  MemoEx1->SelectAll();
}
//---------------------------------------------------------------------------

AnsiString __fastcall TForm1::MemoEx1BlockOperation(TObject *Sender,
      int MacroID, const AnsiString Text)
{
  //  user-defined block operation (Ctrl-B,{A-Z})
  MessageDlg(Format("Process with: \"%s\"", ARRAYOFCONST((Text))), mtInformation, TMsgDlgButtons() << mbOK, 0);
  return Text;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1BreakLine(TObject *Sender,
      const AnsiString Original, AnsiString &_New)
{
  //  user-processed line break
  AnsiString s = Original;
  s.TrimLeft();
  if (s.Pos(">") == 1) _New = "> " + _New;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1ConcatLine(TObject *Sender,
      const AnsiString Original, AnsiString &_New)
{
  AnsiString s = Original, t = _New;
  s.TrimLeft();
  t.TrimLeft();
  int i = t.Pos(">");
  if (s.Pos(">") == i)
  {
    t.Delete(1, i + 1);
    _New = t;
  }
}
//---------------------------------------------------------------------------

bool __fastcall TForm1::MemoEx1InsertBlock(TObject *Sender,
      AnsiString &Text)
{
  //  insert block from the external source (Ctrl-K,R)
  Text = InputBox("Insert block", "Text to insert from \"external resource\"", "");
  return (Text != "");
}
//---------------------------------------------------------------------------

AnsiString __fastcall TForm1::MemoEx1InsertMacro(TObject *Sender,
      int MacroID)
{
  //  insert user-defined macro (Ctrl-S,{A-Z})
  return Format("Macro%d", ARRAYOFCONST(((int) MacroID)));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1SaveBlock(TObject *Sender,
      const AnsiString Text)
{
#ifndef _RWSTD_NO_NAMESPACE
  using namespace std;
#endif
  //  save block to file (Ctrl-K,W)
  if (SaveDialog->Execute())
  {
    fstream out(SaveDialog->FileName.c_str(), ios_base::out | ios_base::trunc);
    out << Text;
    out.close();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1TextInsert(TObject *Sender,
      AnsiString &Text)
{
  //  user-defined handler for any text insertions
  MessageDlg(Format("Text \"%s\" will be inserted", ARRAYOFCONST((Text))), mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MemoEx1PaintGutter(TObject *Sender,
      TCanvas *Canvas)
{
  //  gutter painter
  int i, j;
  HRGN rgn;
  j = Max(1, (int) (MemoEx1->Height / 100));
  rgn = CreateRectRgn(0, 0, MemoEx1->GutterWidth - 2, MemoEx1->Height);
  SelectClipRgn(Canvas->Handle, rgn);
  for (i = 1; i < j + 1; i++)
    Canvas->Draw(-30, (i - 1) * 100, Image1->Picture->Graphic);
  SelectClipRgn(Canvas->Handle, 0);
  DeleteObject(rgn);
}
//---------------------------------------------------------------------------

